<script setup lang="ts">
  import { ProductListingEventEnum, Sidebar } from '~/components/presentation/model';

  const sidebarName = ref();

  const emits = defineEmits<{
    (e: 'close'): void;
  }>();

  const { editCurrentProductListing, createCurrentProductListing } = useProductListing();
  const leftSidebarController = useLeftSidebar();
  const productListingSidebarLoading = ref<boolean>();

  onMounted(() => {
    sidebarName.value = Sidebar.PRODUCT_LISTING;
  });

  const handleEvents = async (event: ProductListingEventEnum, options?: any) => {
    switch (event) {
      case ProductListingEventEnum.OPEN_PRODUCT_SELECTION_SIDEBAR:
        productListingSidebarLoading.value = true;
        if (options?.slideIndex >= 0) {
          await editCurrentProductListing(options.slideIndex);
        } else {
          createCurrentProductListing();
        }
        productListingSidebarLoading.value = false;
        sidebarName.value = Sidebar.PRODUCT_LISTING_UPSERT;
        break;

      case ProductListingEventEnum.CLOSE_PRODUCT_LISTING_LAYER:
        leftSidebarController.close();
        break;

      case ProductListingEventEnum.GO_BACK:
        if (sidebarName.value === Sidebar.PRODUCT_LISTING_UPSERT) {
          sidebarName.value = Sidebar.PRODUCT_LISTING;
        } else if (sidebarName.value === Sidebar.PRODUCT_LISTING) {
          emits('close');
        }
        break;
      default:
    }
  };
</script>

<template>
  <ProductListingSidebar
    v-if="sidebarName === Sidebar.PRODUCT_LISTING"
    :loading="productListingSidebarLoading"
    @trigger="handleEvents"
  />
  <ProductListingUpsertSidebar
    v-if="sidebarName === Sidebar.PRODUCT_LISTING_UPSERT"
    @trigger="handleEvents"
  />
</template>
